<?php

namespace Controller;

use Traits\TResponse;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;

class Classification
{
    use TResponse;

    /**
     * @var \Service\Classification
     */
    private $classificationService;

    public function __construct(\Service\Classification $classificationService)
    {
        $this->classificationService = $classificationService;
    }

    public function findClassification(Request $request, Response $response)
    {
        try {
            $dataSet = $this->classificationService->findClassifications();
            $this->sendResponse($dataSet, 200);
        } catch (\Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }
}
