<?php

namespace Repository;

use Util\InstanceProvider;
use Teknisa\Model\Traits\TQuery;

class Classification
{
    use TQuery;

    public function findClassifications($organizationId){

      $sql = <<<SQL
      SELECT ID, LABEL, CONTROL, IS_PROJECT, IS_TASK, NOT_ALLOWED_PROJECT_TYPE ,ALLOWED_PROJECT_TYPE, NOT_ALLOWED_PROJECT_STATUS, ESTIMATED_TIME_PROPORTION,
             ALLOWED_PROJECT_STATUS, NULL AS "__is_new", DIVIDE_DURATION, USED_IN_TIME_CONTROL, NRPERFILACESSO, USED_IN_NEWS
      FROM (
             SELECT CLA.ID, CLA.LABEL, CLA.CONTROL, CLA.IS_PROJECT, CLA.IS_TASK, CLA.ESTIMATED_TIME_PROPORTION,CLA.DIVIDE_DURATION,CLA.USED_IN_TIME_CONTROL, CLA.USED_IN_NEWS,
                (SELECT rtrim(xmlagg(xmlelement(e, CP.NRPERFILACESSO,',').extract('//text()') order by CP.NRPERFILACESSO).GetClobVal(),',')
                   FROM CLASSIFICATION_PERFILACESSO CP WHERE CP.CLASSIFICATION = CLA.ID) AS NRPERFILACESSO,
                (SELECT (rtrim(xmlagg(xmlelement(e,CPT.PROJECT_TYPE,',').extract('//text()') order by CPT.ID).GetClobVal(),',')) AS IDS
                   FROM CLASSIFICATION_PROJECT_TYPE CPT WHERE CPT.CLASSIFICATION = CLA.ID AND CPT.TYPE = 'N') AS NOT_ALLOWED_PROJECT_TYPE,
                (SELECT (rtrim(xmlagg(xmlelement(e,CPT.PROJECT_TYPE,',').extract('//text()') order by CPT.ID).GetClobVal(),',')) AS IDS
                   FROM CLASSIFICATION_PROJECT_TYPE CPT WHERE CPT.CLASSIFICATION = CLA.ID AND CPT.TYPE = 'P') AS ALLOWED_PROJECT_TYPE,
                (SELECT (rtrim(xmlagg(xmlelement(e,CTS.TASK_STATUS,',').extract('//text()') order by CTS.ID).GetClobVal(),',')) AS IDS
                   FROM CLASSIFICATION_TASK_STATUS CTS WHERE CTS.CLASSIFICATION = CLA.ID AND CTS.TYPE = 'N') AS NOT_ALLOWED_PROJECT_STATUS,
                (SELECT (rtrim(xmlagg(xmlelement(e,CTS.TASK_STATUS,',').extract('//text()') order by CTS.ID).GetClobVal(),',')) AS IDS
                   FROM CLASSIFICATION_TASK_STATUS CTS WHERE CTS.CLASSIFICATION = CLA.ID AND CTS.TYPE = 'P') AS ALLOWED_PROJECT_STATUS
               FROM CLASSIFICATION CLA
              WHERE CLA.ORGANIZATION = :organizationId)
      WHERE 1 = 1
        AND IS_TASK = 'Y'
SQL;

        $params = array(
            'organizationId' => $organizationId
        );
        
        return $this->createAndExecuteQueryAndBuildResponseData(InstanceProvider::getEntityManager(), $sql, $params);
    }

}