/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_VIATURA                                                  */
/* Tabela : VIATURA                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 26/10/2004 - WELBERT G.MOITINHA                                            */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_VIATURA'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_VIATURA
GO

CREATE TRIGGER DTULTATU_VIATURA
ON VIATURA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'VIATURA', null, 'CDVIATURA=' + CDVIATURA + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE VIATURA
      SET DTULTATUVIAT = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(VIATURA.CDVIATURA,0)  = ISNULL(INSERTED.CDVIATURA,0)) AND
            (ISNULL(VIATURA.NRPLACA,0)    = ISNULL(INSERTED.NRPLACA,0))   AND 
            (ISNULL(VIATURA.DSTIPOVEIC,0) = ISNULL(INSERTED.DSTIPOVEIC,0));
   END;
END;
GO